/*
 *  
 *  Copyright © 2008 Colomban "Ban" Wendling <ban@herbesfolles.org>
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */

/*
 * Creation date: Tue Nov 25 14:50:49 2008 +0100
 * Revision date: Tue Nov 25 16:28:29 2008 +0100
 */



#include "geanyclosetabbutton.h"
#include <gtk/gtk.h>


static void remove_page(GtkWidget* button, GtkWidget* tab_label)
{
	GtkNotebook* nb;
	gint page;
	gint pages;
	
	nb = GTK_NOTEBOOK(gtk_widget_get_parent(tab_label));
	
	pages = gtk_notebook_get_n_pages(nb);
	for (page=0; page < pages; page++)
	{
		GtkWidget* child;
		child = gtk_notebook_get_nth_page(nb, page);
		
		if (gtk_notebook_get_tab_label(nb, child) == tab_label)
		{
			gtk_notebook_remove_page(nb, page);
			break;
		}
	}
}

static GtkWidget* tab_label_new(const gchar* text)
{
	GtkWidget* box;
	GtkWidget* label;
	GtkWidget* button;
	
	box = gtk_hbox_new(FALSE, 4);
	label = gtk_label_new(text);
	gtk_box_pack_start(GTK_BOX(box), label, TRUE, TRUE, 0);
	button = geany_close_tab_button_new();
	gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 0);
	
	g_signal_connect(button, "clicked", G_CALLBACK(remove_page), box);
	
	gtk_widget_show_all(box);
	
	return box;
}


int main(int argc, char** argv)
{
	GtkWidget* nb;
	GtkWidget* win;
	
	gtk_init(&argc, &argv);
	
	win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	g_signal_connect(win, "delete-event", gtk_main_quit, NULL);
	
	nb = gtk_notebook_new();
	gtk_notebook_append_page(GTK_NOTEBOOK(nb), gtk_text_view_new(), tab_label_new("Hello"));
	gtk_notebook_append_page(GTK_NOTEBOOK(nb), gtk_text_view_new(), tab_label_new("Dolly!"));
	gtk_container_add(GTK_CONTAINER(win), nb);
	
	gtk_widget_show_all(win);
	
	gtk_main();
	
	return 0;
}
